<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Smart Folder: Documentation</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Smart Folder
   &#160;<span id="projectnumber">0.1</span>
   </div>
   <div id="projectbrief">Un répertoire virtuel de recherche de fichiers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('index.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Documentation </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="intro_sec"></a>
Introduction</h1>
<p>Ce projet est conceptualisé dans le cadre du cours « Programmation Système ». Le but est de maitriser les appels systèmes sous Linux. <br />
<br />
 Il s’agit d’un programme qui permet de chercher des fichiers et des dossiers selon des critères que l’utilisateur passe en argument, et de créer un répertoire dans lequel le résultat de la recherche va être enregistré sous forme de liens symboliques vers ces fichiers et dossiers.</p>
<h1><a class="anchor" id="use_sec"></a>
Utilisation</h1>
<h4>Expressions : (on commence par &ndash;nomcomplet et on verra pour rajouter -caractère)</h4>
<ol type="1">
<li>Nom du fichier : &ndash;name [string]</li>
<li>Taille du fichier : &ndash;size [+|-|=][int][O|K|M|G] Par défaut : =[int]O</li>
<li>Date de création/modification/utilisation du fichier : &ndash;date [C|M|U][+|-|=][Y/M/D] Par défaut : C=[Y/M/D]</li>
<li>Propriétaire/groupe de propriétaires du fichier : &ndash;owner [U|G][=|!][string] Par défaut : U=[string]</li>
<li>Droits d'accès du fichier : &ndash;mode [E|C][int][int][int] E pour equal, C pour contain. Pour gérer la vérification "contain", si la permission est le chiffre 9, ça veut dire qu'on va ignorer cette partie. Exemple : &ndash;mode C994 ==&gt; revient à chercher les fichiers dont la permission contient 4 (r&ndash;) pour other sans tenir compte de la permission pour user et group. Autre exemple : &ndash;mode C009 ==&gt; revient à chercher les fichiers dont la permission contient 0 pour user et 0 pour group sans tenir compte de la permission pour other</li>
<li>Expression booléenne combinant 1, 2, 3, 4, 5 : Pour combiner deux expressions, il faut les écrire sous la forme polonaise inverse.<br />
 Exemple : &ndash;date M+26/01/2017 &ndash;size =5O and &ndash;name toto or not</li>
</ol>
<h1><a class="anchor" id="demarche"></a>
Démarche d'éxecution</h1>
<h4>Démarche d'éxecution :</h4>
<ol type="1">
<li>main -&gt; vérification des arguments</li>
<li>on envoi la partie [expression] des arguments au parser</li>
<li>le parser parse l'ensemble [expression] en autant de sous ensemble qu'il y a de sous expressions. ex : [[name] and [date] or [size]], le parser va créer 3 structures qui contiendra les critères de chaque expression.</li>
<li>Le filtre va recevoir la table de hashage qu'aura généré le crawler. Le parser va ensuite envoyé le ou les structures au filtre qui va créer autant de listes de fichiers qu'il y a de structures à partir de la table.</li>
<li>le filtre va faire faire les opérations logique entre chaque liste. ex : ((name_list ∩ date_list) ∪ size_list)</li>
<li>le filtre va envoyer la liste finale au linker qui va créer des liens symboliques dans le searchfolder. </li>
</ol>
</div></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Généré par
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
